import { DataXY } from 'cheminfo-types';
import { SGGOptions } from 'ml-savitzky-golay-generalized';
export interface FirstDerivativeFilter {
    name: 'firstDerivative';
    options?: FirstDerivativeOptions;
}
export type FirstDerivativeOptions = Omit<SGGOptions, 'derivative'>;
/**
 * Calculate the first derivative using Savitzky–Golay filter.
 * @param data
 * @param options
 */
export declare function firstDerivative(data: DataXY<Float64Array>, options?: FirstDerivativeOptions): {
    data: {
        x: Float64Array;
        y: Float64Array;
    };
};
//# sourceMappingURL=firstDerivative.d.ts.map