import { DataXY } from 'cheminfo-types';
import { SGGOptions } from 'ml-savitzky-golay-generalized';
export interface SecondDerivativeFilter {
    name: 'secondDerivative';
    options?: SecondDerivativeOptions;
}
export type SecondDerivativeOptions = Omit<SGGOptions, 'derivative'>;
/**
 * Calculate the second derivative using Savitzky–Golay filter.
 * @param data
 * @param options
 */
export declare function secondDerivative(data: DataXY<Float64Array>, options?: SecondDerivativeOptions): {
    data: {
        x: Float64Array;
        y: Float64Array;
    };
};
//# sourceMappingURL=secondDerivative.d.ts.map