import { DataXY, FromTo } from 'cheminfo-types';
export interface FilterXFilter {
    name: 'filterX';
    options?: FilterXOptions;
}
export interface FilterXOptions {
    /**
     * from
     * @default x[0]
     */
    from?: number;
    /**
     * to
     * @default x[x.length - 1]
     */
    to?: number;
    /**
     * number of points
     * @default []
     */
    exclusions?: FromTo[];
    /**
     * array of from / to that should be kept
     * @default [{from,to}]
     */
    zones?: FromTo[];
}
/**
 * Filter that allows to
 * @param data
 * @param options
 */
export declare function filterX(data: DataXY<Float64Array>, options?: FilterXOptions): {
    data: DataXY<number[]>;
};
//# sourceMappingURL=filterX.d.ts.map