import { DataXY } from 'cheminfo-types';
import { SGGOptions } from 'ml-savitzky-golay-generalized';
export interface ThirdDerivativeFilter {
    name: 'thirdDerivative';
    options?: ThirdDerivativeOptions;
}
export type ThirdDerivativeOptions = Omit<SGGOptions, 'derivative'>;
/**
 * Calculate the third derivative using Savitzky–Golay filter.
 * @param data
 * @param options
 */
export declare function thirdDerivative(data: DataXY<Float64Array>, options?: ThirdDerivativeOptions): {
    data: {
        x: Float64Array;
        y: Float64Array;
    };
};
//# sourceMappingURL=thirdDerivative.d.ts.map