"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.thirdDerivative = thirdDerivative;
const ml_savitzky_golay_generalized_1 = require("ml-savitzky-golay-generalized");
/**
 * Calculate the third derivative using Savitzky–Golay filter.
 * @param data
 * @param options
 */
function thirdDerivative(data, options = {}) {
    const { x, y } = data;
    return { data: { x, y: (0, ml_savitzky_golay_generalized_1.sgg)(y, x, { ...options, derivative: 3 }) } };
}
//# sourceMappingURL=thirdDerivative.js.map