import { DataXY } from 'cheminfo-types';
import { GSDOptions } from 'ml-gsd';
export interface CalibrateFilter {
    name: 'calibrateX';
    options?: CalibrateOptions;
}
export interface CalibrateOptions {
    /**
     * from
     * @default x[0]
     */
    from?: number;
    /**
     * to
     * @default x[x.length-1]
     */
    to?: number;
    /**
     * number of points
     * @default 1
     */
    nbPeaks?: number;
    /**
     * define the new X value
     * @default 0
     */
    targetX?: number;
    /**
     * array of from / to that should be kept
     * @default [{from,to}]
     */
    gsd?: GSDOptions;
}
/**
 * Filter that allows to calibrateX the x axis based on the presence of peaks
 * @param data
 * @param options
 */
export declare function calibrateX(data: DataXY<Float64Array>, options?: CalibrateOptions): {
    data: DataXY<Float64Array>;
};
//# sourceMappingURL=calibrateX.d.ts.map