import { DataXY, FromTo } from 'cheminfo-types';
export interface EquallySpacedFilter {
    name: 'equallySpaced';
    options?: EquallySpacedOptions;
}
export interface EquallySpacedOptions {
    /**
     * from
     * @default x[0]
     */
    from?: number;
    /**
     * to
     * @default x[x.length - 1]
     */
    to?: number;
    /**
     * number of points
     * @default 100
     */
    numberOfPoints?: number;
    /**
     * number of points
     * @default []
     */
    exclusions?: FromTo[];
    /**
     * array of from / to that should be kept
     * @default [{from,to}]
     */
    zones?: FromTo[];
}
/**
 * Filter that allows to
 * @param data
 * @param options
 */
export declare function equallySpaced(data: DataXY<Float64Array>, options?: EquallySpacedOptions): {
    data: DataXY<number[]>;
};
//# sourceMappingURL=equallySpaced.d.ts.map