"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setMaxX = setMaxX;
const ml_spectra_processing_1 = require("ml-spectra-processing");
/**
 * Filter that allows to
 * @param data
 * @param options
 */
function setMaxX(data, options = {}) {
    const { max = 1 } = options;
    const existingMax = (0, ml_spectra_processing_1.xMaxValue)(data.x);
    if (existingMax === max) {
        return { data };
    }
    return {
        data: {
            x: (0, ml_spectra_processing_1.xAdd)(data.x, max - existingMax),
            y: data.y,
        },
    };
}
//# sourceMappingURL=setMaxX.js.map