"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setMinX = setMinX;
const ml_spectra_processing_1 = require("ml-spectra-processing");
/**
 * Filter that allows to
 * @param data
 * @param options
 */
function setMinX(data, options = {}) {
    const { min = 0 } = options;
    const existingMin = (0, ml_spectra_processing_1.xMinValue)(data.x);
    if (existingMin === min) {
        return { data };
    }
    return {
        data: {
            x: (0, ml_spectra_processing_1.xAdd)(data.x, min - existingMin),
            y: data.y,
        },
    };
}
//# sourceMappingURL=setMinX.js.map