"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setMaxY = setMaxY;
const ml_spectra_processing_1 = require("ml-spectra-processing");
/**
 * Filter that allows to
 * @param data
 * @param options
 */
function setMaxY(data, options = {}) {
    const { max = 1 } = options;
    const existingMax = (0, ml_spectra_processing_1.xMaxValue)(data.y);
    if (existingMax === max) {
        return { data };
    }
    return {
        data: {
            x: data.x,
            y: (0, ml_spectra_processing_1.xAdd)(data.y, max - existingMax),
        },
    };
}
//# sourceMappingURL=setMaxY.js.map