"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setMinY = setMinY;
const ml_spectra_processing_1 = require("ml-spectra-processing");
/**
 * Filter that allows to
 * @param data
 * @param options
 */
function setMinY(data, options = {}) {
    const { min = 0 } = options;
    const existingMin = (0, ml_spectra_processing_1.xMinValue)(data.y);
    if (existingMin === min) {
        return { data };
    }
    return {
        data: {
            x: data.x,
            y: (0, ml_spectra_processing_1.xAdd)(data.y, min - existingMin),
        },
    };
}
//# sourceMappingURL=setMinY.js.map